using Itrycn_Project;
using ryCommon;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Itrycn_Project2
{
    public partial class FrmScan : Form
    {
        string[] prog_args;
        public FrmScan(string[] args)
        {
            InitializeComponent();
            prog_args = args;
            //配置软件信息
            notifyIcon1.Text = Soft_Info.Soft_Title;
            Text = Soft_Info.Soft_Title + " V" + RySoft.VersionStr;
            if (!Soft_Info.ShowTray) { notifyIcon1.Visible = false; }
            if (!Soft_Info.DonateVisabled) { 捐助ToolStripMenuItem.Text = "关于"; }
            if (Soft_Info.Soft_Url.Length == 0) { 打开官网ToolStripMenuItem.PerformClick(); }
            notifyIcon1.Icon = Icon;
        }

        private void 显示主窗体ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Normal;
            var topmost = this.TopMost;
            this.TopMost = true;
            this.Show();
            this.TopMost = topmost;
        }

        private void 退出软件ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void FrmStart_Shown(object sender, EventArgs e)
        {
            ryCommon.Ini ini = new Ini(Soft_Info.UserDataFolder + "\\Win.dat");
            ini.WriteIni(Soft_Info.Soft_Id, "hwnd", Handle.ToInt32());
            if (prog_args.Length >= 1)
            {
                //如果是自启动,并且开启了右下角托盘图标,则隐藏自身。
                if (prog_args[0] == Soft_Info.Soft_Pram && Soft_Info.ShowTray)
                    this.Hide();
            }
        }

        private void FrmStart_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (Soft_Info.ShowTray && Soft_Config.HideByCloseBtn && e.CloseReason== CloseReason.UserClosing)
            {
                e.Cancel = true;
                this.Hide();
                notifyIcon1.ShowBalloonTip(3000, Soft_Info.Soft_Title, "软件已经最小化到此处,请右击托盘图标进行关闭。", ToolTipIcon.Info);
                return;
            }
            if (!Soft_Config.IsCanCloseForm)
            {
                e.Cancel = true;
                MessageBox.Show("当前还有操作正在运行,请稍后关闭软件。", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
        protected override void WndProc(ref System.Windows.Forms.Message msg)
        {
            switch (msg.Msg)
            {
                case 17189: //处理消息
                    {
                        #region 激活窗体
                        switch (msg.WParam.ToInt32())
                        {
                            case 100://
                                #region 显示界面
                                if ((int)msg.LParam.ToInt32() == 100)
                                {
                                    this.Show();
                                    this.WindowState = FormWindowState.Normal;
                                    this.Top = (Screen.PrimaryScreen.WorkingArea.Height - this.Height) / 2;
                                    this.Left = (Screen.PrimaryScreen.WorkingArea.Width - this.Width) / 2;
                                    //RyForm.SetActiveWindow(Handle);
                                    RyForm.BringToTop(Handle);
                                    显示主窗体ToolStripMenuItem.PerformClick();
                                    this.BringToFront();
                                    this.Select();
                                    this.Focus();
                                    RyForm.BringToTop(Handle);
                                }
                                #endregion
                                break;
                        }
                        #endregion
                    }
                    break;
                default:
                    base.WndProc(ref msg);//调用基类函数处理非自定义消息。
                    break;
            }
        }

        private void 捐助ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Soft_Info.DonateVisabled)
            {
                FrmAbout frm = new FrmAbout();
                frm.ShowDialog();
                frm.Dispose();
            }
            else
            {
                MessageBox.Show(Soft_Info.AboutText.Replace("#softname#", Soft_Info.Soft_Title).Replace("#ver#", "V" + RySoft.VersionStr), "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }


        private void 打开官网ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ryCommon.RyFiles.OpenUrl(Soft_Info.Soft_Url);
        }

        private void FrmStart_Load(object sender, EventArgs e)
        {
            //Itrycn_Project.Itrycn_Db.CreateTable();
            LiveUpdate.RyUpdate update = new LiveUpdate.RyUpdate(Soft_Info.Update_Url);
            update.CheckUpdate();
        }
    }
}
